import { Form } from '../../e2elib/lib/src/pageobjects/form.component';
import { ListSOP } from '../../libappsop/listsop';
import { DialogRecipeAssignment } from '../dialogs/dialog.recipeassignment';

export class FormRecipeAssignment extends Form {
  public listRecipeAssignment = new ListRecipeAssignment();

  public constructor() {
    super('FormProductRecipes');
  }
}

export class ListRecipeAssignment extends ListSOP<DialogRecipeAssignment, ListRecipeAssignmentColumn> {
  public static readonly title = 'Recipe Assignments';

  public constructor() {
    super('ListRecipeWithEffectiveDate', new DialogRecipeAssignment());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { 'Product name': '', 'Recipe name': '', 'Effective date': '' };
  }
}

export interface ListRecipeAssignmentColumn {
  'Product name'?: string;
  'Recipe name'?: string;
  'Effective date'?: string;
}

const listRecipeAssignmentContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuRecipeWithEffectiveDate', Name: 'MenuCreate', Label: 'Create' },
  Delete: { ContextMenu: 'listContextMenuRecipeWithEffectiveDate', Name: 'MenuDelete', Label: 'Delete' },
};

export { listRecipeAssignmentContextMenuItem as ListRecipeAssignmentContextMenuItem };
